﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;
using Telerik.Charting;

namespace RadChartViewExampleVS10
{
    public partial class Form1 : RadForm
    {
        private Random rnd = new Random();

        public Form1()
        {
            InitializeComponent();

            ScatterSeries series = new ScatterSeries();

            for (int i = 0; i < 20; i++)
            {
                series.DataPoints.Add(this.rnd.Next(0, 100), this.rnd.Next(0, 100));
            }

            this.radChartView1.Series.Add(series);

            this.radChartView1.MouseWheel += radChartView1_MouseWheel;
        }

        private void radChartView1_MouseWheel(object sender, System.Windows.Forms.MouseEventArgs e)
        {
            SizeF newZoom = new SizeF(1f, 1f);

            if (e.Delta > 0)
            {
                // zoom in
                newZoom.Width = (float)((IChartView)this.radChartView1.View).ZoomWidth * 1.1f;
            }
            else
            {
                // zoom out
                float xZoom = (float)((IChartView)this.radChartView1.View).ZoomWidth / 1.1f;

                if (xZoom >= 1)
                {
                    newZoom.Width = xZoom;
                }
                else
                {
                    newZoom.Width = 1; // zoom out to max
                }
            }

            double oldStretchedAreaWidth = this.radChartView1.View.Viewport.Width * ((IChartView)this.radChartView1.View).ZoomWidth;
            Point point = e.Location;
            double ratio = (point.X - ((IChartView)this.radChartView1.View).PlotOriginX) / oldStretchedAreaWidth;

            this.radChartView1.Zoom(newZoom.Width, newZoom.Height);
            double newStretchedAreaWidth = this.radChartView1.View.Viewport.Width * newZoom.Width;
            double panOffset = ratio * newStretchedAreaWidth - point.X;

            this.radChartView1.Pan(-panOffset, 0);
        }

        private void radButton1_Click(object sender, EventArgs e)
        {
        }
    }
}